import sys
import dolgozat
import hasonlosag


def main():
    """Főprogram."""

    # Ha nincs paraméter, akkor súgó megjelenítése
    if len(sys.argv) < 2 or len(sys.argv) > 3:
        print("Plágiumdetektor\n\n"
              "Használat: {} <vezérlőfájl> [kimeneti_fájl]\n\n"
              "A vezérlőfájl formátuma soronként:\n"
              "  fájlnév szerző_neve\n"
              "A fájlnév nem tartalmazhat szóközöket, a szerző neve viszont igen.".format(sys.argv[0]));
        sys.exit(0)

    # Paraméterek értelmezése
    vezerlofajl = sys.argv[1]
    kimeneti_fajl = None if len(sys.argv) < 3 else sys.argv[2]

    # Adatok beolvasása
    try:
        dolgozatok = dolgozat.vezerlofajl_beolvas(vezerlofajl)
    except Exception as e:
        print("Nem sikerült beolvasni a vezérlőfájlt:", e, file=sys.stderr)
        sys.exit(1)
    try:
        dolgozat.dolgozatok_beolvas(dolgozatok)
    except Exception as e:
        print("Nem sikerült beolvasni valamelyik dolgozatot:", e, file=sys.stderr)
        sys.exit(2)
    
    # Összehasonlítás
    hasonlosagok = hasonlosag.osszeset_hasonlit(dolgozatok)
    hasonlosag.hasonlosag_rendez(hasonlosagok)

    # Eredmény fájlba (ha van név), vagy szabványos kimenetre
    if kimeneti_fajl is None:
        for h in hasonlosagok[:20]:
            print(h)
    else:
        try:
            hasonlosagok_fajlba(hasonlosagok, kimeneti_fajl)
        except Exception as e:
            print("Hiba a hasonlóságok fájlba írásakor:", e, file=sys.stderr)
            sys.exit(3)


main()
